import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Adventure extends JFrame {

  private JButton[] buttons = new JButton[20];
  private JTextArea track;
  private JTextField chooser;
  private JLabel label;
  private JButton magic;
  private JButton doIt;
  private Container conPane;
  private GridBagLayout layout;
  private GridBagConstraints constraints;
  private static final int WIDTH = 400;
  private static final int HEIGHT = 400;
  private String taFont = "Welcome To OMAdventure...\n\nThe Best Choose Your Own Adventure " +
    "Game Available";
  private static ImageIcon magicIcon = new ImageIcon("c:\\Presentation Pics\\hplogo.jpg");
  
  public Adventure() {

    super("Adventure");
    conPane = getContentPane();
    layout = new GridBagLayout();
    conPane.setLayout(layout);
    constraints = new GridBagConstraints();
    track = new JTextArea(taFont);
    track.setLineWrap(true);
    track.setEditable(false);
    constraints.weightx = 1;
    constraints.weighty = 1;
    constraints.fill = GridBagConstraints.BOTH;
    addComponent(new JScrollPane(track), 0, 0, 9, 3);
    label = new JLabel("Choose Your Adventure Wisely");
    addComponent(label, 3, 0, 2, 2);
    chooser = new JTextField("Enter Starting Point");
    addComponent(chooser, 3, 2, 3, 2);
    magic = new JButton("Magic", magicIcon);
    magic.setVerticalTextPosition(SwingConstants.BOTTOM);
    magic.setHorizontalTextPosition(SwingConstants.CENTER);
    addComponent(magic, 3, 5, 2, 2);
    doIt = new JButton("DO IT");
    addComponent(doIt, 3, 7, 2, 2);
    setUpButtons();
    setSize(WIDTH,HEIGHT);
    setVisible(true);
  }

  private void setUpButtons() {

    constraints.weightx = 1;
    constraints.weighty = 1;
    constraints.fill = GridBagConstraints.BOTH;
    for(int i = 0; i < buttons.length; i++) {
      buttons[i] = new JButton("option" + i, magicIcon);
      addComponent(buttons[i], 5, i, 1, 1);
    }
  }

  private void addComponent(Component component, int row, int column, int width, int height) {

    constraints.gridx = column;
    constraints.gridy = row;
    constraints.gridwidth = width;
    constraints.gridheight = height;
    layout.setConstraints(component, constraints);
    conPane.add(component);
  }

  public static void main(String[] args) {
    
    Adventure myAdventure = new Adventure();
    myAdventure.setDefaultCloseOperation(EXIT_ON_CLOSE);
  }
}
