package OMAdventure.GUI;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import java.net.*;
import java.util.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
//import javax.media.*;
import OMAdventure.*;

class Big extends JFrame {

    //private data variables
    private Container conPane;

    private JPanel all;
    private JPanel stuff;
    private JPanel options;
    private JPanel topOne;
    private JPanel holder;
    private JPanel worldCon;
    private JPanel controller;
    private JPanel locater;
    private JPanel topText;
    
    private JButton[] buttons;
    private JButton levelUp;
    private JButton curLevel;
    private JButton upArrow;
    private JButton rightArrow;
    private JButton downArrow;
    private JButton leftArrow;
    private JButton magic;
    //  private JButton playMusic;
    
    private JLabel room;
    private JLabel label;
    //private JLabel curVol;

    private JTextArea track;
    private JTextField chooser;

    private JScrollPane bigScroll;
    private JScrollPane smallScroll;

    //private JComboBox musicOpts;
    //private JSlider volume;

    private String goalStr = Goal.getRandom();
    private String nStr = null;
    private String bStr = null;
    private String taFont = "Welcome To OMAdventure...\n\nThe Best Choose Your Own " +
	"Adventure Game Available\n\nClick an object in the room or\nclick magic to " +
	"add something new\n";
    /*
    private String[] songs = { 
	"Lynyrd Skynyrd-Sweet Home Alabama",
	"2Pac-How Do U Want It",
	"311-You Wouldn't Believe",
	"Boyz II Men-Thank You",
	"Eminem-Lose Yourself", 
	"James-Laid",
	"Jennifer Lopez-Jenny From The Block",
	"Linkin Park-Papercut",
	"Ozzy Osbourne-Crazy Train",
	"Police-Message In A Bottle",
	"Queen-Killer Queen",
	"Santana feat Rob Thomas-Smooth",
	"Savatage-Christmas Eve",
	"Scorpions-No One Like You",
	"Tiffany-I Think We're Alone Now",
	"Tonic-If You Could Only See",
	"Weezer-Buddy Holly",
	"Stop Player"
	};*/
  
    private FileWriter writer;
    private PrintWriter out;

    private boolean addObject = false;
    private boolean addPlace = false;
    private boolean useMagic = false;

    private ImageIcon emptyIcon = new ImageIcon("Empty.jpg");
    private ImageIcon alwaysIcon = new ImageIcon("Always.jpg");
    private ImageIcon oftenIcon = new ImageIcon("Often.jpg");
    private ImageIcon sometimesIcon = new ImageIcon("Sometimes.jpg");
    private ImageIcon rarelyIcon = new ImageIcon("Rarely.jpg");
    private ImageIcon neverIcon = new ImageIcon("Never.jpg");
    private ImageIcon closeToIcon = new ImageIcon("Close.jpg");
    private ImageIcon attachedToIcon = new ImageIcon("Attached.jpg");
    private ImageIcon insideOfIcon = new ImageIcon("Inside.jpg");
    private ImageIcon farFromIcon = new ImageIcon("Far.jpg");
    private ImageIcon upArrowIcon = new ImageIcon("Up Arrow.jpg");
    private ImageIcon rightArrowIcon = new ImageIcon("Right Arrow.jpg");
    private ImageIcon downArrowIcon = new ImageIcon("Down Arrow.jpg");
    private ImageIcon leftArrowIcon = new ImageIcon("Left Arrow.jpg");
    private ImageIcon magicIcon = new ImageIcon("Magic.jpg");
    private ImageIcon playMusicIcon = new ImageIcon("Play Music.jpg");
    private ImageIcon doNothingIcon = new ImageIcon("Do Nothing.jpg");
    private ImageIcon addObjectIcon = new ImageIcon("Add Object.jpg");
    private ImageIcon addPlaceIcon = new ImageIcon("Add Place.jpg"); 
    private ImageIcon addItIcon = new ImageIcon("Add It.jpg");

    private World myWorld; 
    
    public Big() {
    
	//The Overall JFrame
	super("OMAdventure v1.0");
	JOptionPane.showMessageDialog(null, ("The goal is to get to " + goalStr), "Goal", 
				      JOptionPane.YES_OPTION);
	conPane = getContentPane();
	conPane.setLayout(new GridLayout(1,1));
	
	//Creation of the world...will comment out the next line upon completion
	myWorld = new World();
	//objDB = new ObjectDB();

	//Creating the JTextArea with a JScrollPane
	track = new JTextArea(taFont+"You are in the "+(myWorld.getPlace()).getPlace()+"\n");
	track.setFont(new Font("SanSerif", Font.BOLD, 16));
	track.setLineWrap(true);
	track.setEditable(false);
	track.setBackground(Color.yellow);
	smallScroll = new JScrollPane(track);
	
	//Creating the Level Up and CurLevel JButtons
	String startStr = (myWorld.getPlace()).getPlace();
	levelUp = new JButton("Up One Level");
	levelUp.setFont(new Font("SanSerif", Font.BOLD+Font.ITALIC, 14));
	levelUp.setHorizontalTextPosition(SwingConstants.CENTER);
	levelUp.setBorderPainted(false);
	levelUp.setBackground(Color.blue);
	curLevel = new JButton("Exploring the " + startStr);
	curLevel.setHorizontalTextPosition(SwingConstants.CENTER);
	curLevel.setFont(new Font("SanSerif", Font.BOLD+Font.ITALIC, 24));
	curLevel.setBorderPainted(false);
	curLevel.setBackground(Color.blue);
	
	//creating a JPanel for levelUp & curLevel
	topText = new JPanel(new GridLayout(2,1));
	topText.setBackground(Color.blue);
	topText.add(curLevel);
	topText.add(levelUp);

	//Creating the room JLabel and the associated Arrows
	room = new JLabel(FinalDay.scaleImg(getPics(startStr), 250, 250));
	upArrow = new JButton(FinalDay.scaleImg(upArrowIcon.getImage(), 50, 50));
	upArrow.setBorderPainted(false);
	upArrow.setBackground(Color.blue);
	rightArrow = new JButton(FinalDay.scaleImg(rightArrowIcon.getImage(), 50, 50));
	rightArrow.setBorderPainted(false);
	rightArrow.setBackground(Color.blue);
	downArrow = new JButton(FinalDay.scaleImg(downArrowIcon.getImage(), 50, 50));
	downArrow.setBorderPainted(false);
	downArrow.setBackground(Color.blue);
	leftArrow = new JButton(FinalDay.scaleImg(leftArrowIcon.getImage(), 50, 50));
	leftArrow.setBorderPainted(false);
	leftArrow.setBackground(Color.blue);
	setDButtons();

	//Creating the JPanel to hold the room JLabel and Arrows and adding the items
	locater = new JPanel(new BorderLayout());
	locater.setBackground(Color.blue);
	locater.add(room, BorderLayout.CENTER);
	locater.add(upArrow, BorderLayout.NORTH);
	locater.add(rightArrow, BorderLayout.EAST);
	locater.add(downArrow, BorderLayout.SOUTH);
	locater.add(leftArrow, BorderLayout.WEST);
	
	//Creating the JPanel to hold the previous JPanel and level up button
	worldCon = new JPanel(new BorderLayout());
	worldCon.setBackground(Color.blue);
	worldCon.add(topText, BorderLayout.NORTH);
	worldCon.add(locater, BorderLayout.CENTER);
	
	//Creating the JPanel to hold the previous JPanel and smallScroll
	topOne = new JPanel(new GridLayout(1,2));
	topOne.add(smallScroll);
	topOne.add(worldCon);
	
	//Creating the items for the center panel
	label = new JLabel("Enter Stuff Here");
	label.setHorizontalAlignment(SwingConstants.CENTER);
	label.setBackground(Color.cyan);
	chooser = new JTextField(null, 20);
	magic = new JButton(FinalDay.scaleImg(magicIcon.getImage(), 75, 75));
	magic.setText("Magic");
	allign(magic);
	magic.setBorderPainted(false);
	magic.setBackground(Color.cyan);
	/*
	musicOpts = new JComboBox(songs);
	musicOpts.setBorder(new CompoundBorder());
	musicOpts.setBackground(Color.cyan);
	playMusic = new JButton(FinalDay.scaleImg(playMusicIcon.getImage(), 75, 75));
	playMusic.setText("Play Music");
	playMusic.setBorderPainted(false);
	playMusic.setBackground(Color.cyan);
	allign(playMusic);
	volume = new JSlider();
	volume.setBackground(Color.cyan);
	curVol = new JLabel("Volume: 50%");
	curVol.setHorizontalAlignment(SwingConstants.CENTER);
	
	//Creating the JPanel to hold the music controls
	controller = new JPanel(new GridLayout(3,1));
	controller.setBackground(Color.cyan);
	controller.add(musicOpts);
	controller.add(volume);
	controller.add(curVol);
	*/
	//Creating the JPanel to hold the center items
	holder = new JPanel(new FlowLayout());
	holder.setBackground(Color.cyan);
	holder.add(label);
	holder.add(chooser);
	holder.add(magic);
	//holder.add(controller);
	//holder.add(playMusic);
	
	//Creating the JPanel to hold the top and middle JPanels
	stuff = new JPanel(new BorderLayout());
	stuff.add(topOne, BorderLayout.CENTER);
	stuff.add(holder, BorderLayout.SOUTH);
	
	//Creating the option buttons as well as the JPanel to hold them
	options = new JPanel(new GridLayout(3,5));
	options.setBackground(Color.green);
	buttons = new JButton[15];
	for(int i = 0; i < buttons.length; i++) {
	    buttons[i] = new JButton("Option " + (i+1), emptyIcon);
	    allign(buttons[i]);
	    buttons[i].setBorderPainted(false);
	    buttons[i].setBackground(Color.green);
	    buttons[i].setVisible(false);
	    options.add(buttons[i]);
	}
	fillButtons((myWorld.getPlace()).getChildren());
	setButtonAction();

	//Creating the JPanel that will hold all the other JPanels
	all = new JPanel(new BorderLayout());
	all.add(stuff, BorderLayout.CENTER);
	all.add(options, BorderLayout.SOUTH);
	
	//Creating the JScrollPane for the whole frame and adding the last JPanel
	bigScroll = new JScrollPane(all, ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS, 
				    ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
	conPane.add(bigScroll);
	setSize(850, 850);
	setVisible(true);
	setDefaultCloseOperation(EXIT_ON_CLOSE);

	//Creating a new out file and allowing data to be appended
	try {
	    writer = new FileWriter("OMData.txt", true);
	    out = new PrintWriter(writer);
	}
	catch(IOException e) {
	    System.out.println("Cannot create output file");
	}
	
	//Creating Action Listeners for all of the Arrows
	
	levelUp.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
		    String str = "You are exploring " + (myWorld.getPlace()).getParent() +
			" from the " + (myWorld.getPlace()).getPlace() + "\n";
		    checkEnd();
		    boolean b = myWorld.moveParent();
		    if(b) {
			track.append(str);
			String s = (myWorld.getPlace()).getPlace();
			room.setIcon(FinalDay.scaleImg(getPics(s), 250, 250));
			fillButtons((myWorld.getPlace()).getChildren());
		    }
		    setDButtons();
		}
            });

	upArrow.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    String str = "You are exploring " + (myWorld.getPlace()).getNorth() +
			" from the " + (myWorld.getPlace()).getPlace() + "\n";
		    checkEnd();
		    boolean b = myWorld.moveNorth();
		    if(b) {
			track.append(str);
			String s = (myWorld.getPlace()).getPlace();
			room.setIcon(FinalDay.scaleImg(getPics(s), 250, 250));
			fillButtons((myWorld.getPlace()).getChildren());
		    }
		    setDButtons();
		}
	    }); 
	
	rightArrow.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    String str = "You are exploring " + (myWorld.getPlace()).getEast() +
			" from the " + (myWorld.getPlace()).getPlace() + "\n";
		    checkEnd();
		    boolean b = myWorld.moveEast();
		    if(b) {
			track.append(str);
			String s = (myWorld.getPlace()).getPlace();
			room.setIcon(FinalDay.scaleImg(getPics(s), 250, 250));
			fillButtons((myWorld.getPlace()).getChildren());
		    }
		    setDButtons();
		}
	    });
	
	downArrow.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    String str = "You are exploring " + (myWorld.getPlace()).getSouth() +
			" from the " + (myWorld.getPlace()).getPlace() + "\n";
		    checkEnd();
		    boolean b = myWorld.moveSouth();
		    if(b) {
			track.append(str);
			String s = (myWorld.getPlace()).getPlace();
			room.setIcon(FinalDay.scaleImg(getPics(s), 250, 250));
			fillButtons((myWorld.getPlace()).getChildren());
		    }
		    setDButtons();
		}
	    });
	
	leftArrow.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    String str = "You are exploring " + (myWorld.getPlace()).getWest() +
			" from the " + (myWorld.getPlace()).getPlace() + "\n";
		    checkEnd();
		    boolean b = myWorld.moveWest();
		    if(b) {
			track.append(str);
			String s = (myWorld.getPlace()).getPlace();
			room.setIcon(FinalDay.scaleImg(getPics(s), 250, 250));
			fillButtons((myWorld.getPlace()).getChildren());
		    }
		    setDButtons();
		}
	    });
	/*
	//Creating an ActionListener for the playMusic JButton
	playMusic.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    String s = (String)musicOpts.getSelectedItem();
		if(s.equals(songs[songs.length-1]))
		    FinalNew.stopMP3();
		else {
		    float v = volume.getValue() / 100.0F;
		    FinalNew.playMP3(new File(s + ".mp3"));
		    FinalNew.changeVol(v);
		}
		}
	    });
	
	//Creating an ChangeListener for the volume JSlider
	volume.addChangeListener(new ChangeListener() {
		public void stateChanged(ChangeEvent e) {
		    float v = volume.getValue() / 100.0F;
		    FinalNew.changeVol(v);
		    curVol.setText("Volume: " + volume.getValue() + "%");
		}
	    });
	*/ 
	//Creating an ActionListener for the magic JButton
	magic.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    if((chooser.getText()).length() > 2) {
			if(!(goalStr.equals(chooser.getText()))) {
			track.append("Are you adding a new object or a new location?\n");
			buttons[0].setIcon(addObjectIcon);
			buttons[0].setText("Add Object");
			buttons[0].setVisible(true);
			allign(buttons[0]);
			buttons[1].setIcon(addPlaceIcon);
			buttons[1].setText("Transport");
			buttons[1].setVisible(true);
			allign(buttons[1]);
			for(int i = 2; i < 15; i++)
			    buttons[i].setVisible(false);
			useMagic = true;
			setButtonAction();
			}
			else {
			    JOptionPane.showMessageDialog(null, "Cheater, enter a string that's not the goal",
							  "Cheater", JOptionPane.YES_OPTION);
			}
		    }
		    else {
			JOptionPane.showMessageDialog(null,"Please enter some text!", "warning", 
						      JOptionPane.YES_OPTION);
		    }
		}
	    });
    }



    //Method that will give a button the correct action    
    private void setButtonAction() {
	
	  for(int i = 0; i < buttons.length; i++) {
	      ActionListener[] al = buttons[i].getActionListeners();
	      for(int j = 0; j < al.length; j++) {
		  buttons[i].removeActionListener(al[j]);
	      }
		  buttons[i].addActionListener(new ActionListener() {
			  public void actionPerformed(ActionEvent e) {
			      if(addObject) {
				  if(!(((JButton)e.getSource()).equals(buttons[5]))) {
				      if(((JButton)e.getSource()).equals(buttons[0]))
					  nStr += " is always ";
				      else if(((JButton)e.getSource()).equals(buttons[1]))
					  nStr += " is often ";
				      else if(((JButton)e.getSource()).equals(buttons[2]))
					  nStr += " is sometimes ";
				      else if(((JButton)e.getSource()).equals(buttons[3]))
					  nStr += " is rarely ";
				      else if(((JButton)e.getSource()).equals(buttons[4]))
					  nStr += " is never ";
				      nStr += "found in a " + (myWorld.getPlace()).getPlace();
				      track.append(nStr + " was added to OMCS\n");
				      out = new PrintWriter(writer);
				      out.println(nStr);
				      out.close();
				  }
				  myWorld.addChild(chooser.getText());
				  fillButtons((myWorld.getPlace()).getChildren());
				  useMagic = false;
				  addObject = false;
				  setDButtons();
			      }
			      else if(addPlace) {
				  if(!(((JButton)e.getSource()).equals(buttons[4]))) {
				      if(((JButton)e.getSource()).equals(buttons[0]))
					  nStr += " is far from ";
				      else if(((JButton)e.getSource()).equals(buttons[1]))
					  nStr += " is close to ";
				      else if(((JButton)e.getSource()).equals(buttons[2]))
					  nStr += " is attached to ";
				      else if(((JButton)e.getSource()).equals(buttons[3]))
					  nStr += " is inside of ";
				      nStr += "a " + (myWorld.getPlace()).getPlace();
				      track.append(nStr + " was added to OMCS\n");
				      out = new PrintWriter(writer);
				      out.println(nStr);
				      out.close();
				  } 
				  String s = chooser.getText();
				  myWorld.move(s);
				  room.setIcon(FinalDay.scaleImg(getPics(s), 250, 250));
				  fillButtons((myWorld.getPlace()).getChildren());
				  useMagic = false;
				  addPlace = false;
				  setDButtons();
			      }
			      else if(useMagic) {
				  if(((JButton)e.getSource()).equals(buttons[0])) {
				      nStr = "A " + chooser.getText();
				      track.append(nStr + " is always, often, sometimes, rarely " +
						   " or never in " +
						   (myWorld.getPlace()).getPlace() + "\n");
				      buttons[0].setIcon(alwaysIcon);
				      buttons[0].setText("Always");
				      buttons[0].setVisible(true);
				      allign(buttons[0]);
				      buttons[1].setIcon(oftenIcon);
				      buttons[1].setText("Often");
				      buttons[1].setVisible(true);
				      allign(buttons[1]);
				      buttons[2].setIcon(sometimesIcon);
				      buttons[2].setText("Sometimes");
				      buttons[2].setVisible(true);
				      allign(buttons[2]);
				      buttons[3].setIcon(rarelyIcon);
				      buttons[3].setText("Rarely");
				      buttons[3].setVisible(true);
				      allign(buttons[3]);
				      buttons[4].setIcon(neverIcon);
				      buttons[4].setText("Never");
				      buttons[4].setVisible(true);
				      allign(buttons[4]);
				      buttons[5].setIcon(doNothingIcon);
				      buttons[5].setText("Do Not Add");
				      buttons[5].setVisible(true);
				      allign(buttons[5]);
				      for(int i = 6; i < 15; i++)
					  buttons[i].setVisible(false);
				      addObject = true;
				  }
				  if(((JButton)e.getSource()).equals(buttons[1])) {
				      nStr = chooser.getText();
				      track.append(nStr + " is far from, close to, attached to\n" + 
						   "or inside of a " + (myWorld.getPlace()).getPlace() + "\n");
				      buttons[0].setIcon(farFromIcon);
				      buttons[0].setText("Far From");
				      buttons[0].setVisible(true);
				      allign(buttons[0]);
				      buttons[1].setIcon(closeToIcon);
				      buttons[1].setText("Close To");
				      buttons[1].setVisible(true);
				      allign(buttons[1]);
				      buttons[2].setIcon(attachedToIcon);
				      buttons[2].setText("Attached To");
				      buttons[2].setVisible(true);
				      allign(buttons[2]);
				      buttons[3].setIcon(insideOfIcon);
				      buttons[3].setText("Inside Of");
				      buttons[3].setVisible(true);
				      allign(buttons[3]);
				      buttons[4].setIcon(doNothingIcon);
				      buttons[4].setText("Do Not Add");
				      buttons[4].setVisible(true);
				      allign(buttons[4]);
				      for(int i = 5; i < 15; i++)
					  buttons[i].setVisible(false);
				      addPlace = true;
				  }
			      }
			      else {
				  String str = ((JButton)e.getSource()).getText();
				  String s = "You are exploring " + str +
				      " in the " + (myWorld.getPlace()).getPlace() + "\n";
				  track.append(s);
				  checkEnd();
				  boolean b = myWorld.moveChild(str);
				  if(b) {
				      String sTr = (myWorld.getPlace()).getPlace();
				      room.setIcon(FinalDay.scaleImg(getPics(sTr), 250, 250));
				      fillButtons((myWorld.getPlace()).getChildren());
				  }
				  setDButtons();
			      }
			  }
		      });
	     
	  }
    }

    //Method to see if we're at the goal state
    private void checkEnd() {
	if(goalStr.equals((myWorld.getPlace()).getPlace())) {
	    JOptionPane.showMessageDialog(null, "Congratulations, You Won!!", "Winner", JOptionPane.YES_OPTION);
	    goalStr = Goal.getRandom();
	    JOptionPane.showMessageDialog(null, "Your new goal is " + goalStr, "New Goal", JOptionPane.YES_OPTION);
	}
    }
    
    //Method to allign the text in a JButton on the bottom and centered
        private void allign(JButton b) {
	b.setHorizontalTextPosition(SwingConstants.CENTER);
	b.setVerticalTextPosition(SwingConstants.BOTTOM);
    }

    //Method that will fill the buttons with the appropriate icon and visibility
    private void fillButtons(Vector v) {
	int total = v.size();
	if(total >= 15) {
	    total = 15;
	    for(int i = 0; i < total; i++) {
		String s = (String)v.get(i);
		Image img = getPics(s);
		if(img != null) {
		    buttons[i].setIcon(new ImageIcon(img));
		    buttons[i].setText(s);
		    buttons[i].setVisible(true);
		}
		else {
		    buttons[i].setIcon(emptyIcon);
		    buttons[i].setText("Option " + (i+1));
		    buttons[i].setVisible(false);
		}
	    }
	}
	else {
	    int rest = 15 - total;
	    for(int i = 0; i < total; i++) {
		String s = (String)v.get(i);
		Image img = getPics(s);
		if(img != null) {
		    buttons[i].setIcon(new ImageIcon(img));
		    buttons[i].setText(s);
		    buttons[i].setVisible(true);
		}
		else {
		    buttons[i].setIcon(emptyIcon);
		    buttons[i].setText("Option " + (i+1));
		    buttons[i].setVisible(false);
		}
	    }
	    for(int j = 0; j < rest; j++) {
		buttons[total+j].setIcon(emptyIcon);
		buttons[total+j].setText("Option " + (total+j+1));
		buttons[total+j].setVisible(false);
	    }
	}
    }
    
    //Method that will set the text of the directional buttons
    public void setDButtons() {
	//bStr = (myWorld.getPlace()).getPlace();
	if((myWorld.getPlace()).getPlace() != null)
	    curLevel.setText("Exploring the " + (myWorld.getPlace()).getPlace());
	else
	    curLevel.setText("Nothing There");
	curLevel.setHorizontalTextPosition(SwingConstants.CENTER);

	//bStr = (myWorld.getPlace()).getParent();
	if((myWorld.getPlace()).getParent() != null)
	    levelUp.setText("Zoom Out To " + (myWorld.getPlace()).getParent());
	else
	    levelUp.setText("Nothing There");
	levelUp.setHorizontalTextPosition(SwingConstants.CENTER);
	
	//bStr = (myWorld.getPlace()).getNorth();
	if((myWorld.getPlace()).getNorth() != null)
	    upArrow.setText("To " + (myWorld.getPlace()).getNorth());
	else
	    upArrow.setText("Nothing There");
	allign(upArrow);
	
	bStr = (myWorld.getPlace()).getEast();
	if(bStr != null)
	    rightArrow.setText("To " + bStr);
	else
	    rightArrow.setText("Nothing There");
	allign(rightArrow);
	
	bStr = (myWorld.getPlace()).getSouth();
	if(bStr != null)
	    downArrow.setText("To " + bStr);
	else
	    downArrow.setText("Nothing There");
	allign(downArrow);
	
	bStr = (myWorld.getPlace()).getWest();
	if(bStr != null)
	    leftArrow.setText("To " + bStr);
	else
	    leftArrow.setText("Nothing There");
	allign(leftArrow);
    }

    //method that grabs the first Image from AltaVista Image Gallery
    public Image getPics(String c) {
	URL url = null;
	c =	c.replace(' ','+');
	String strURL = "http://www.altavista.com/image/results?q=" + c + "&avkw=qtrp";
	try {
	    url = new URL(strURL);
	}
	catch(MalformedURLException e) {
	    e.printStackTrace();
	    return null;
	}
	try {
	    Object content = url.getContent();
	    BufferedReader reader = new BufferedReader(new
		InputStreamReader((InputStream) content));
	    String line;
	    StringBuffer stbuf = new StringBuffer();
	    while ((line = reader.readLine()) != null) {
		stbuf.append(line + "\n");
	    }
	    String content1 = stbuf.toString();
	    int start = content1.indexOf("\u003B\"><img src")+13;
	    int finish = content1.indexOf("\"",start+1);
	    String strURL2 = content1.substring(start,finish);
	    URL url2 = new URL(strURL2);
	    return createImage( (ImageProducer) url2.getContent());
	}
	catch(IOException e) {
	    e.printStackTrace();
	    return null;
	}
    }
}

public class FinalDay {

    //private variables
    //private static Player pb = null;
    //private static GainControl gc = null;
    
    //method that scales a given image and puts it into an ImageIcon
    public static ImageIcon scaleImg(Image i, int w, int h) {
	Image si = i.getScaledInstance(w, h, Image.SCALE_SMOOTH);
	return new ImageIcon(si);
    }
    /*
    //initializes the MP3 player and plays the MP3 file
    public static void playMP3(File file) {
	try {
	    if(pb != null) {
		pb.stop();
		pb.close();
		pb = null;
	    }
	    MediaLocator ml = new MediaLocator(file.toURL());
	    pb = Manager.createRealizedPlayer(ml);
	    pb.start();
	    gc = pb.getGainControl();
	}
	catch(MalformedURLException u) {
	    System.out.println("Bad URL name");
	}
	catch(javax.media.NoPlayerException npe) {
	    System.out.println("No player available");
	}
	catch(javax.media.CannotRealizeException cre) {
	    System.out.println("Cannont Realize the player");
	}
	catch(IOException i) {
	    System.out.println("IO Exception");
	}
    }
   
    //changes the volume
    public static void changeVol(float f) {
	gc.setLevel(f);
    }
    
    //stops the MP3 player
    public static void stopMP3() {
	pb.stop();
	pb.close();
	pb = null;
    }
    */ 
    //main method
    public static void main(String[] args) {
	Big itsBig = new Big();
    }
}
