package OMAdventure;

//import edu.brandeis.cs.steele.wn.*;
import java.util.*;

import OMAdventure.omcs.*;
import OMAdventure.GUI.*;
//import OMAdventure.wordnet.*;

public class World {

	static Vector locs;
	static Location currentRoom;
	static jOMCS omcs;
	static Words fileWords;

	public World () {

		System.out.println(Goal.getRandom());		
		fileWords = new Words();
		System.out.println("File Database Loaded");
		omcs = new jOMCS();
		System.out.println("OMCS Loaded");		
		locs = new Vector();
		currentRoom = new Location("town");
		locs.add(currentRoom);
		addAllDirs();
	}

	public static boolean addNorth() {
	//	System.out.println("North");
		if (!currentRoom.hasNorth()) {
			Location tempL = addNeighbor(0,currentRoom);
			if (tempL == null) { System.out.println("NOTHING2"); return false; }
			else {
				currentRoom.setNorth(tempL.getPlace());
				tempL.setParent(currentRoom.getParent());	
			}
			return true;
		}
		return false;
	}

	public static boolean moveNorth() {
		Location cRoom = getRoom(currentRoom.getNorth());
		if (cRoom == null) {
			return false;
		}
		else {
			currentRoom = cRoom;
			addAllDirs();
			return true;
		}
	}

	public static boolean moveSouth() {
		Location cRoom = getRoom(currentRoom.getSouth());
		if (cRoom == null) {
			return false;
		}
		else {
			currentRoom = cRoom;
			addAllDirs();
			return true;
		}
	}
	public static boolean moveEast() {
		Location cRoom = getRoom(currentRoom.getEast());
			if (cRoom == null) {
			return false;
		}
		else {
			currentRoom = cRoom;
			addAllDirs();
			return true;
		}
	}
	public static boolean moveWest() {
		Location cRoom = getRoom(currentRoom.getWest());
		if (cRoom == null) {
			return false;
		}
		else {
			currentRoom = cRoom;
			addAllDirs();
			return true;
		}
	}
	public static boolean moveParent() {
		Location cRoom = getRoom(currentRoom.getParent());
			if (cRoom == null) {
			return false;
		}
		else {
			currentRoom = cRoom;
			addAllDirs();
			return true;
		}
	}


	public static boolean addSouth() {
		if (!currentRoom.hasSouth()) {
			Location tempL = addNeighbor(1,currentRoom);
			if (tempL == null) { return false; }
			else {
				currentRoom.setSouth(tempL.getPlace());
				tempL.setParent(currentRoom.getParent());
			}
			return true;
		}
		return false;
	}

	public static boolean addEast() {
		if (!currentRoom.hasEast()) {
			Location tempL = addNeighbor(2,currentRoom);
			if (tempL == null) { return false; }
			else {
				currentRoom.setEast(tempL.getPlace());
				tempL.setParent(currentRoom.getParent());
			}
			return true;
		}
		return false;
	}

	public static boolean addWest() {
		if (!currentRoom.hasWest()) {
			Location tempL = addNeighbor(3,currentRoom);
			if (tempL == null) { return false; }
			else {
				currentRoom.setWest(tempL.getPlace());
				tempL.setParent(currentRoom.getParent());
			}
			return true;
		}
		return false;
	}

	public static boolean addChildren() {
		//MUST: add random objects from Dave's DB
		Vector children;
		if (currentRoom.hasChildren()) {
			children = currentRoom.getChildren();
			if (children.size() < 15) {
				Vector v = getRandomChildren(10-children.size());
				Iterator viter = v.iterator();
				while (viter.hasNext()) {
					String temp = (String)viter.next();
					if (!children.contains(temp)) {
						children.add(temp);
					}
				}
			}
		}
		else {
			children = getRandomChildren(10);
		}
		if (children != null) {
			Iterator chit = children.iterator();
			while (chit.hasNext()) {
				String str = (String) chit.next();
				Location loc1 = new Location(str);
				locs.add(loc1);
				loc1.setParent(currentRoom.getPlace());
			}
		
			currentRoom.addChildren(children);
			return true;
		}
		return false;
	}

	public static void addAllDirs() {
		addParent();
		addNorth();
		addWest();
		addEast();
		addSouth();
		addChildren();
	}

	public static boolean addParent() {
		if (!currentRoom.hasParent()) {
			Location tempL = new Location(createParent());
			if (tempL == null) { System.out.println("SHOOT"); return false; }
			else {
				locs.add(tempL);
				tempL.addChild(currentRoom.getPlace());
				currentRoom.setParent(tempL.getPlace());
			}
			return true;
		}
		return false;
	}

	public static void move(String place) {
		Location cRoom = getRoom(place);
		if (cRoom == null) {
			cRoom = new Location(place);
			locs.add(cRoom);
		}
		currentRoom = cRoom;
		addAllDirs();
	}
	
	public static boolean addChild(String child) {
		currentRoom.addChild(child);
		return true;
	}

	public static boolean moveChild(String child) {
			Vector children = currentRoom.getChildren();
	  		if (children != null) {
				Iterator chiter = children.iterator();	
				while (chiter.hasNext()) {
					String child2 = (String) chiter.next();
					if (child2.equals(child)) {
					    // Location cRoom = getRoom(child);
					    if (getRoom(child) == null) {
						currentRoom = new Location(child);
					    }
					    else currentRoom = getRoom(child);
					addAllDirs();
					return true;
				}
			}
		}
			Location loc2 = new Location(child);
			locs.add(loc2);
			currentRoom.addChild(loc2.getPlace());	
			loc2.setParent(currentRoom.getPlace());
			currentRoom = loc2;
			addAllDirs();
			return false;
	} 

	public static Location getPlace() {
		return currentRoom;
	}

	public static Location getRoom(String s) {
		Iterator it = locs.iterator();
		while (it.hasNext()) {
			Location loc1 = (Location) it.next();
			if (((String)loc1.getPlace()).equals(s)) {
				return loc1;
			}
		}
		return null;
	}

	public static Location addNeighbor(int n,Location room) {
		String place = randomPlace();
		if (place == null) {
//			System.out.println("HERE WE GO");
			return null;
		}
//		System.out.println("PLACE = " + place);
		Location loc1 = new Location(place);
		Vector surroundings = new Vector();
		if (currentRoom.hasEast()) {
			surroundings.add(currentRoom.getEast());
		}
		if (currentRoom.hasWest()) {
			surroundings.add(currentRoom.getWest());
		}
		if (currentRoom.hasNorth()) {
			surroundings.add(currentRoom.getNorth());
		}
		if (currentRoom.hasSouth()) {
			surroundings.add(currentRoom.getSouth());
		}
		System.out.println("CC " + getChildrenCount());
		if (getChildrenCount() > surroundings.size()) {
			System.out.println("Here");
			while (surroundings.contains(loc1.getPlace())) {
				loc1 = new Location(randomPlace());
			}
		}
		else {
			System.out.println("HERE I AM");
			return null;
		} 
		locs.add(loc1);
		switch(n) {

			case 0:
				loc1.setSouth(currentRoom.getPlace());
				currentRoom.setNorth(loc1.getPlace());
				break;
			case 1:
				loc1.setNorth(currentRoom.getPlace());
				currentRoom.setSouth(loc1.getPlace());
				break;
			case 2:
				loc1.setWest(currentRoom.getPlace());
				currentRoom.setEast(loc1.getPlace());
				break;
			case 3:
				loc1.setEast(currentRoom.getPlace());
				currentRoom.setWest(loc1.getPlace());
				break;
			
		}
		return loc1;
	}

	public static String createParent() {
		Nodes nodes = (Nodes)omcs.getNodes(currentRoom.getPlace());
		Vector children = new Vector();
    	Vector cc = nodes.getProperties("hasLocation",true);	
		if (cc != null) {
			children.addAll((Collection)cc);
		}
		Collection coll = ((Collection)fileWords.getChildren(currentRoom.getPlace()));	
		if (coll != null) {
			children.addAll(coll);
		}
		Vector remlist = new Vector();
		coll = ((Collection)fileWords.getAntiChildren(currentRoom.getPlace()));
		if (coll != null) {
			remlist.addAll(coll);
		}
	    if (children != null) {
		Iterator chiter = children.iterator();	
		while (chiter.hasNext()) {
			String child = (String) chiter.next();
			/*omwordnet omw = new omwordnet(child);
			if (!omw.isWord()) {
				remlist.add(child);
			}*/
		 if ((child.length() >= 4) && (child.substring(0,4).equals("some"))) {
//				System.out.println(child + " found");
				remlist.add(child);
			}
		}
		Iterator remiter = remlist.iterator();
		while (remiter.hasNext()) {
			String str2 = (String) remiter.next();
			if (children.contains(str2)) {
				children.remove(str2);
			}
		}
		if (children.size() == 0) {return null;}
		Random rn = new Random();		
		int j = rn.nextInt(children.size());
//		System.out.println((String)children.elementAt(j));
		return (String)children.elementAt(j);
	  }
		return null;
	}

	public static String createChild() {

		Nodes nodes = (Nodes)omcs.getNodes(currentRoom.getPlace());
		Vector children = nodes.getProperties("hasLocation",false);		
		Random rn = new Random();		
		int j = rn.nextInt(children.size());
		return (String)children.elementAt(j);
	}

	public static int getChildrenCount() {
	/*	Nodes nodes = (Nodes)omcs.getNodes(currentRoom.getParent());
		Vector v = ((Vector)nodes.getProperties("hasLocation",false));
		if (v == null)
			return 0;
		else 
			return v.size();
	*/
		Vector children = new Vector();
		Nodes nodes = (Nodes)omcs.getNodes(currentRoom.getParent());
    	Vector cc = nodes.getProperties("hasLocation",false);	
		if (cc != null) {
			children.addAll((Collection)cc);
		}
		Collection coll = ((Collection)fileWords.getChildren(currentRoom.getPlace()));	
		if (coll != null) {
			children.addAll(coll);
		}
		if (children == null) {
			return 0;
		}
		Vector remlist = new Vector();
		coll = ((Collection)fileWords.getAntiChildren(currentRoom.getPlace()));
		if (coll != null) {
			remlist.addAll(coll);
		}
		Iterator chiter = children.iterator();	
		while (chiter.hasNext()) {
			String child = (String) chiter.next();
			/*omwordnet omw = new omwordnet(child);
			if (!omw.isWord()) {
				remlist.add(child);
			}*/
		 if ((child.length() >= 4) && (child.substring(0,4).equals("some"))) {
//				System.out.println(child + " found");
				remlist.add(child);
			}
		}
		Iterator remiter = remlist.iterator();
		while (remiter.hasNext()) {
			String str2 = (String) remiter.next();
			if (children.contains(str2)) {
				children.remove(str2);
			}
		}
		if (children == null) {
			return 0;
		}
		else {
			return children.size();
		}
		
	}
	

	public static Vector getRandomChildren(int n) {
		Vector children = new Vector();
		Nodes nodes = (Nodes)omcs.getNodes(currentRoom.getPlace());
    	Vector cc = nodes.getProperties("hasLocation",false);	
		if (cc != null) {
			children.addAll((Collection)cc);
		}
		Collection coll = ((Collection)fileWords.getChildren(currentRoom.getPlace()));	
		if (coll != null) {
			children.addAll(coll);
		}
		if (children == null) {
			return null;
		}
		Vector remlist = new Vector();
		coll = ((Collection)fileWords.getAntiChildren(currentRoom.getPlace()));
		if (coll != null) {
			remlist.addAll(coll);
		}
		Iterator chiter = children.iterator();	
		while (chiter.hasNext()) {
			String child = (String) chiter.next();
			/*omwordnet omw = new omwordnet(child);
			if (!omw.isWord()) {
				System.out.println("REMOVE: " + child);
				remlist.add(child);
			}*/
			 if ((child.length() >= 4) && (child.substring(0,4).equals("some"))) {
//				System.out.println(child + " found");
				remlist.add(child);
			}
		}
		Iterator remiter = remlist.iterator();
		while (remiter.hasNext()) {
			String str2 = (String) remiter.next();
			if (children.contains(str2)) {
				children.remove(str2);
			}
		}
		if (children.size() <= n) {
			return children;
		}
		else {
			Vector children2 = new Vector();
			boolean [] list = new boolean[children.size()];
			for (int i = 0; i < n; i++)
				list[i] = false;
		   int count = 0;
		  while (count < n) {
			Random rn = new Random();		
			int j = rn.nextInt(children.size());
			if (list[j] == false) {
				list[j] = true;
				children2.add((String)children.elementAt(j));
				count++;
			}			
		  }
		  return children2;
		}
	}

	public static String randomPlace() {
		//randomly gets room;
		//checks for duplicate room
		Nodes nodes = (Nodes)omcs.getNodes(currentRoom.getParent());
		String parent = (currentRoom.getParent());
		Vector children = new Vector();
    	Vector cc = nodes.getProperties("hasLocation",false);	
		if (cc != null) {
			children.addAll((Collection)cc);
		}
		Collection coll = ((Collection)fileWords.getChildren(currentRoom.getParent()));		
		if (coll != null) {
			children.addAll(coll);
		}
	
	if (children != null) {
		Vector remlist = new Vector();
		coll = ((Collection)fileWords.getAntiChildren(currentRoom.getParent()));
		if (coll != null) {
			remlist.addAll(coll);
		}
		Iterator chiter = children.iterator();	
		while (chiter.hasNext()) {
			String child = (String) chiter.next();
			/*omwordnet omw = new omwordnet(child);
			if (!omw.isWord()) {
				remlist.add(child);
			}*/
			if ((child.length() >= 4) && (child.substring(0,4).equals("some"))) {
//				System.out.println(child + " found");
				remlist.add(child);
			}
		}
		Iterator remiter = remlist.iterator();
		while (remiter.hasNext()) {
			String str2 = (String) remiter.next();
			if (children.contains(str2)) {
				children.remove(str2);
			}
		}
	//	if (children == null) System.out.println("NOTHING");			

			Random rn = new Random();
			if (children.size() == 0) { return null; }
			int j = rn.nextInt(children.size());
			String ss = (String)children.elementAt(j);
			while (ss.equals(currentRoom.getPlace())) {
			    j = rn.nextInt(children.size());
				ss = (String)children.elementAt(j);
			}
//			System.out.println("asdf " + ss);
//			if (ss == null) System.out.println("NLL NOW");
		return ss;
		}
		return null;
	}
}
