import OMCSNet
import string,re, time
import java
from types import *

class OMCSNetJava(java.lang.Object):

    theOMCSNet = None
    
    def __init__(self):
        "@sig public OMCSNetJava()"
        self.theOMCSNet = OMCSNet.OMCSNet()
        
    def GetNode(self,nodename):
        "@sig public String GetNode(String nodename)"
        # the above line is a java signature
        edges = self.theOMCSNet.get(nodename)
        # return edges in this format
        # pred%node%sentence%fwbw%0.1|pred2%node2%sentence2%fwbw2%0.2...
        output = string.join(map(lambda edge:string.join(map(str,edge),'%'),edges),'|')
        return output

    def GetContext(self,nodename):
        "@sig public String GetContext(String nodename)"
        # the above line is a java signature
        pairs = self.theOMCSNet.spreadingactivation(nodename)
        # returns the format:
        # node1%0.95|node2%0.9|
        output = string.join(map(lambda edge:string.join(map(str,edge),'%'),pairs),'|')
        return output
    
    def FindPathsBetween(self,node1,node2):
        "@sig public String FindPathsBetween(String node1, String node2)"
        # the above line is a java signature
        paths = self.theOMCSNet.find_paths_between(node1,node2)
        # return paths in this format.. paths joined by '^'
        # pred%node%sentence%fwbw%0.1|pred2%node2%sentence2%fwbw2%0.2^pred%node%sentence%fwbw%0.1|pred2%node2%sentence2%fwbw2%0.2
        output = string.join(map(lambda path:string.join(map(lambda edge:string.join(map(str,edge),'%'),path),'|'),paths),'^')
        return output

        
