package OMAdventure.wordnet;

import edu.brandeis.cs.steele.wn.*;
import java.util.*;

public class omwordnet {

	private static int iIndent = 0;
    private static boolean bExtended = true;
	private static Vector parents;
	private static Vector descrips;
	private static int n = 0;
	private static Synset sense = null;
	private static int sIndent = 0;

    private static void traverse(PointerTarget sense, PointerType pointerType)  {

	    PointerTarget[] parents2 = sense.getTargets(pointerType);
		String str = sense.getLongDescription();

		if ((n == -1) || (iIndent >= n)) {
				int indexA = str.indexOf("--");
				String description;
				if (indexA == -1) {
					indexA = str.length();
					description = null;
				}
				else {
					description = str.substring(indexA+4,str.length()-1);
					
				}
				StringTokenizer sToken = new StringTokenizer(str.substring(0,indexA-1),",");
				//while (sToken.hasMoreTokens()) { //add if you want to include synonyms of things
					String str2 = (String) sToken.nextToken();
					parents.add(str2);
					descrips.add(description);
//				}
		}
			sIndent++;
       		for (int j = 0; j < parents2.length; ++j) {
				 iIndent++;
   		 	     traverse(parents2[j], pointerType);
				 iIndent--;
   			}
     }

	public static Vector getAllHypo() {
		n = -1;
		getType(sense,PointerType.HYPONYM);
		return parents;
	}

	public static Vector getHypo(int depth) {
		n = depth;
		getType(sense,PointerType.HYPONYM);
		return parents;
	}
	
	public static Vector getAllHyper() {
		n = -1;
		getType(sense,PointerType.HYPERNYM);
		return parents;
	}

	public static Vector getHyper(int depth) {
		n = depth;
		getType(sense,PointerType.HYPERNYM);
		return parents;
	}


	public static Vector getAllParts() {
		n = -1;
		getType(sense,PointerType.PART_HOLONYM);
		return parents;
	}

	public static Vector getParts(int depth) {
		n = depth;
		getType(sense,PointerType.PART_HOLONYM);
		return parents;
	}


	public omwordnet(String ss) {
		parents = new Vector();

		DictionaryDatabase dictionary = new FileBackedDictionary();
		IndexWord word = dictionary.lookupIndexWord(POS.NOUN, ss);
		if (word != null) {
			Synset[] senses = word.getSenses();
			int taggedCount = word.getTaggedSenseCount();
			//System.out.print("The " + word.getPOS().getLabel() + " " + word.getLemma() + " has " + senses.length + " sense" + (senses.length == 1 ? "" : "s") + " ");
		
			sense = senses[0];
		}
	}
	
	public static Vector getType(Synset sense,PointerType pt) {
		parents = new Vector();
		descrips = new Vector();
		traverse(sense,pt);
		Iterator it = parents.iterator();
		System.out.println("Parents:\n");
		while (it.hasNext()) {
			String str = (String)it.next();
			System.out.println(str);
		}
		return parents;
	}
}

